unit Params;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Mask, Buttons, ComCtrls, ChurchCensus;

type
  TParameters = class(TForm)
    Panel1: TPanel;
    OKBtn: TBitBtn;
    NumRelLbl: TLabel;
    NumLgRelsLbl: TLabel;
    ParameterLbl: TLabel;
    NumLgRelsBox: TMaskEdit;
    NumSmRelsBox: TMaskEdit;
    StartPctReligBar: TTrackBar;
    PctSecularLbl: TLabel;
    PctLbl1: TLabel;
    PctLbl2: TLabel;
    PctLbl3: TLabel;
    AtStartLbl: TLabel;
    AttractionLbl: TLabel;
    AttExpLbl: TLabel;
    LgRelAttractBar: TTrackBar;
    SmRelAttractBar: TTrackBar;
    LowLbl1: TLabel;
    SmLbl: TLabel;
    PlausRateBar: TTrackBar;
    LowLbl2: TLabel;
    PlausChlngLbl: TLabel;
    PlausExpLbl: TLabel;
    SecRateBar: TTrackBar;
    LowLbl3: TLabel;
    HighLbl1: TLabel;
    HighLbl2: TLabel;
    HighLbl3: TLabel;
    SizeRatioBox: TMaskEdit;
    SizeRatioLbl: TLabel;
    LgRelInvestBar: TTrackBar;
    HiLbl4: TLabel;
    LoLbl4: TLabel;
    InvRateLbl: TLabel;
    InvExpLbl: TLabel;
    SmRelInvestBar: TTrackBar;
    LgLbl: TLabel;
    NORelInvestBar: TTrackBar;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure OKBtnClick(Sender: TObject);
    procedure NumLgRelsBoxChange(Sender: TObject);
    procedure SizeRatioBoxChange(Sender: TObject);
    procedure StartPctReligBarChange(Sender: TObject);
    procedure LgRelAttractBarChange(Sender: TObject);
    procedure SmRelAttractBarChange(Sender: TObject);
    procedure PlausRateBarChange(Sender: TObject);
    procedure SecRateBarChange(Sender: TObject);
    procedure LgRelInvestBarChange(Sender: TObject);
    procedure NORelInvestBarChange(Sender: TObject);
    procedure NumSmRelsChange(Sender: TObject);
    procedure SmRelInvestBarChange(Sender: TObject);
{    procedure StPTrackBarChange(Sender: TObject);}
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Parameters: TParameters;

implementation

uses Main, Grid, Settings;

{$R *.DFM}


procedure TParameters.OKBtnClick(Sender: TObject);
begin
  NumLgRel := StrToInt(NumLgRelsBox.Text);
  if NumLgRel <> 0 then NoLarge := false;
  NumSmRel := StrToInt(NumSmRelsBox.Text);
  If NumSmRel <> 0 then NoSmall := false;
  SizeRatio := StrToInt(SizeRatioBox.Text);
  PctSecular := (10*(10-StartPctReligBar.Position));
  SmRelAttraction := SmRelAttractBar.Position;
  LgRelAttraction := LgRelAttractBar.Position;
  PlausibilityRate := PlausRateBar.Position;
  SecularizationRate := SecRateBar.Position;
  LgInvRate := LgRelInvestBar.Position;
  SmInvRate := SmRelInvestBar.Position;
  NOInvRate := NORelInvestBar.Position;
{  StPaulFactor := StPTrackBar.Position;}
{  if BarrierCheckBox.State = cbChecked then TreatAsBarrier := true
                                         else TreatAsBarrier := false;  }
  MainScreen.DescriptionLbl.Visible := false;
  MainScreen.TitleLabel.Visible := false;
  MainScreen.AuthorLbl.Visible := false;
  MainScreen.EmailLbl.Visible := false;
  MainScreen.FreewareLbl.Visible := false;
  MainScreen.CopyrightLbl.Visible := false;

  MainScreen.ResetSimulation.Enabled := true;
  MainScreen.RunOne.Enabled := true;
  MainScreen.RunFive.Enabled := true;
  MainScreen.RunTen.Enabled := true;
  MainScreen.Run50.Enabled := true;
  GridForm.CountChurches;
  SettingsForm.Show;
  SettingsForm.DisplayStart;
  ChurchForm.Show;
  ChurchForm.DisplayStart;
  GridForm.Show;
  GridForm.DisplayStart;
  Close;
end;

procedure TParameters.NumLgRelsBoxChange(Sender: TObject);
begin
  OKBtn.Enabled := false;
  if (NumLgRelsBox.Text = '') then NumLgRelsBox.Text := '0';
  if ((NumLgRelsBox.Text <> '') AND
     (StrToInt(NumLgRelsBox.Text) <= 3) AND
     (NumSmRelsBox.Text <> '') AND
     (StrToInt(NumSmRelsBox.Text) <= 8)) AND
     (SizeRatioBox.Text <> '') AND
     (StrToInt(SizeRatioBox.Text) <= 9) AND
     (StrToInt(SizeRatioBox.Text) >= 4)then
     if ((StrToInt(NumLgRelsBox.Text) > 0) OR
        (StrToInt(NumSmRelsBox.Text) > 0))
    then OKBtn.Enabled := true else OKBtn.Enabled := false;
end;


procedure TParameters.NumSmRelsChange(Sender: TObject);
begin
  OKBtn.Enabled := false;
  if (NumSmRelsBox.Text = '') then NumSmRelsBox.Text := '0';
  if ((NumLgRelsBox.Text <> '') AND
     (StrToInt(NumLgRelsBox.Text) <= 3) AND
     (NumSmRelsBox.Text <> '') AND
     (StrToInt(NumSmRelsBox.Text) <= 8)) AND
     (SizeRatioBox.Text <> '') AND
     (StrToInt(SizeRatioBox.Text) <= 9) AND
     (StrToInt(SizeRatioBox.Text) >= 4)then
     if ((StrToInt(NumLgRelsBox.Text) > 0) OR
        (StrToInt(NumSmRelsBox.Text) > 0))
    then OKBtn.Enabled := true else OKBtn.Enabled := false;

end;

procedure TParameters.SizeRatioBoxChange(Sender: TObject);
begin
  OKBtn.Enabled := false;
  if (SizeRatioBox.Text = '') then SizeRatioBox.Text := '4';
  if ((NumLgRelsBox.Text <> '') AND
     (StrToInt(NumLgRelsBox.Text) <= 3) AND
     (NumSmRelsBox.Text <> '') AND
     (StrToInt(NumSmRelsBox.Text) <= 8)) AND
     (SizeRatioBox.Text <> '') AND
     (StrToInt(SizeRatioBox.Text) <= 9) AND
     (StrToInt(SizeRatioBox.Text) >= 4)then
     if ((StrToInt(NumLgRelsBox.Text) > 0) OR
        (StrToInt(NumSmRelsBox.Text) > 0))
    then OKBtn.Enabled := true else OKBtn.Enabled := false;
end;

procedure TParameters.StartPctReligBarChange(Sender: TObject);
begin
  PctSecular := (10*(10-StartPctReligBar.Position));
end;

procedure TParameters.LgRelAttractBarChange(Sender: TObject);
begin
  LgRelAttraction := LgRelAttractBar.Position;
end;

procedure TParameters.SmRelAttractBarChange(Sender: TObject);
begin
  SmRelAttraction := SmRelAttractBar.Position;

end;

procedure TParameters.PlausRateBarChange(Sender: TObject);
begin
  PlausibilityRate := PlausRateBar.Position;
end;

{procedure TParameters.StPTrackBarChange(Sender: TObject);
begin
  StPaulFactor := StPTrackBar.Position;
end;
 }
procedure TParameters.SecRateBarChange(Sender: TObject);
begin
  SecularizationRate := SecRateBar.Position;
end;


procedure TParameters.LgRelInvestBarChange(Sender: TObject);
begin
  LgInvRate := LgRelInvestBar.Position;
end;


procedure TParameters.SmRelInvestBarChange(Sender: TObject);
begin
  SmInvRate := SmRelInvestBar.Position;
end;

procedure TParameters.NORelInvestBarChange(Sender: TObject);
begin
  NOInvRate := NORelInvestBar.Position;
end;











end.
